import { world } from '@minecraft/server';

world.gameRules.keepInventory = true;

world.afterEvents.entityDie.subscribe((data) => {
    let entDie = data.deadEntity;
    let damage = data.damageSource;

    if (entDie.typeId == 'minecraft:player') {
        let { x, y, z } = entDie.location;
        let dimensionId = entDie.dimension.id.replace('minecraft:','');

        if (damage.cause == 'void') {
            entDie.runCommand('fill ~3 1 ~3 ~-3 1 ~-3 end_stone');
            entDie.runCommand('fill ~3 2 ~3 ~-3 4 ~-3 air replace end_stone');
        };

        entDie.runCommand(`fill ~3 ~3 ~3 ~-3 ~-3 ~-3 magma replace lava`);
        entDie.runCommand(`fill ~3 ~3 ~3 ~-3 ~-3 ~-3 magma replace flowing_lava`);
        entDie.runCommand(`fill ~2 ~2 ~2 ~-2 ~-2 ~-2 air replace magma`);

        grave(entDie, x, damage.cause == 'void' ? 3 : y, z);
        entDie.sendMessage(`§e${entDie.name}§r died in §b${dimensionId}§r at the coordinates §cX: ${Math.floor(x)}§r, §cY: ${Math.floor(y)}§r, §cZ: ${Math.floor(z)}§r.`);
    };

});

world.afterEvents.entityHitEntity.subscribe((data) => {
    let entHit = data.hitEntity;

    if (entHit.typeId == 'thini:gravestone') {
        entHit.triggerEvent('spawn_item');
    };

});

function grave(entDie, x, y, z) {
    const entGrave = entDie.dimension.spawnEntity('thini:gravestone', {x:x, y:y, z:z})
    entGrave.nameTag = `§eR.I.P\n§r${entDie.name}`;
    const getInvGrave = entGrave.getComponent('inventory').container;
    const getInvPlayer = entDie.getComponent('inventory').container;
    const equip = entDie.getComponent('equippable');
    let inv = [];

    for (let i = 0; i < getInvPlayer.size; i++) {
        inv.push(getInvPlayer.getItem(i));
    };

    for (let i = 0; i < getInvGrave.size; i++) {
        getInvGrave.setItem(i, inv[i]);
    };

    equip.getEquipment('Head') ? getInvGrave.addItem(equip.getEquipment('Head')) : null;
    equip.getEquipment('Chest') ? getInvGrave.addItem(equip.getEquipment('Chest')) : null;
    equip.getEquipment('Legs') ? getInvGrave.addItem(equip.getEquipment('Legs')) : null;
    equip.getEquipment('Feet') ? getInvGrave.addItem(equip.getEquipment('Feet')) : null;
    equip.getEquipment('Offhand') ? getInvGrave.addItem(equip.getEquipment('Offhand')) : null;

    entDie.runCommand("clear @s");

    entGrave.setRotation({...entDie.getRotation()});
};
